#include <qapplication.h>
#include "ProjectionModel.h"
#include "RSync.h"
#include "GUIControler.h"

//#include "Q4puGenericSignalSpy.h"
//#include <QTextEdit>

using namespace projection;

int main(int argc, char** argv)
{
	QApplication app(argc,argv);

//  app.setStyle("windows");
    app.setStyle("plastique");

	ProjectionModel model;

    bool bServer = true;
    QString address = model.getRSync()->getHostName();
    int portNo = DEFAULT_PORT_NO;
    QString fileName;
    for (int i=1; i<argc; ++i)
    {
        if (stricmp(argv[i], "-c") == 0 || stricmp(argv[i], "-client") == 0)
            bServer = false;
        else if (stricmp(argv[i], "-address") == 0 && i+1 < argc)
            address = argv[i+1];
        else if ((stricmp(argv[i], "-port") == 0 || stricmp(argv[i], "-portno") == 0) && i+1 < argc)
            portNo = atoi(argv[i+1]);
        else
            fileName = argv[i];
    }

    if (bServer)
    {
        model.initServer(portNo);
        if (!fileName.isEmpty())
            model.getGUI()->loadFile(fileName);
    }
    else
        model.initClient(address, portNo);

	app.exec();
}
