#include <QApplication>
#include "gui/QClientWindow.h"

#include "glrc/glrc.h"

using namespace projection;

QClientWindow::QClientWindow(QWidget* pParent, Qt::WFlags flags)
    : QMainWindow(pParent, flags)
{
    ui.setupUi(this);

    glrcInit();

    statusBar();
}

QClientWindow::~QClientWindow()
{
}

void QClientWindow::appendLog(const QString& line)
{
    ui.logEdit->append(line.trimmed());
}

void QClientWindow::on_actionFileExit_triggered()
{
    qApp->closeAllWindows();
}
